<%@ Page Language="c#" %>
<%@ Register TagPrefix="uc1" TagName="SiteTop" Src="SiteTop.ascx" %>
<%@ Register TagPrefix="uc1" TagName="SiteBottom" Src="SiteBottom.ascx" %>
<%@ Import Namespace="System.Data"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<html>
	<head>
		<title>Manager</title>
		<link rel='stylesheet' href='SiteStyle.css' />
	</head>
	<body>
		<form id="Form1" method="post" runat="server">
			<uc1:SiteTop id="SiteTop1" runat="server"></uc1:SiteTop>
			<table cellSpacing="0" cellPadding="0" class="Container" align="center" border="0">
				<tr>	
					<td width=10 nowrap></td>
					<td>	
						<h3>Manage Administrators</h3>
					<div class="divx">(Default administrator account is
						<%=System.Configuration.ConfigurationSettings.AppSettings["DefaultAdminUsername"]%>
						)
					</div>
					<br>
						<asp:DataGrid Runat="server" id="DataGrid1" BorderColor="#CCCCCC" BorderStyle="None" BorderWidth="1px"
							BackColor="White" CellPadding="3" AutoGenerateColumns="False" Width="500px" 
							DataKeyField="LoginName">
							<HeaderStyle Font-Bold="True" BackColor="#eeeeee"></HeaderStyle>
							<Columns>
								<asp:BoundColumn DataField="LoginName" HeaderText="LoginName"></asp:BoundColumn>
								<asp:BoundColumn DataField="Password" HeaderText="Password"></asp:BoundColumn>
								<asp:ButtonColumn Text="Remove" CommandName="Delete"></asp:ButtonColumn>
							</Columns>
						</asp:datagrid>
					<br>
					<div class="divx">Username :
						<asp:textbox id="AdminUsernameBox" Runat="server" TextMode="SingleLine"></asp:textbox>
						<asp:button id="AddAdminButton" Runat="server" Text="Set as administrator"></asp:button>
					</div>
						<div style="HEIGHT:40px">
							<DIV>
								<asp:Label id="MessageLabel" runat="server" ForeColor="Maroon" EnableViewState="False" Visible="False">Label</asp:Label></DIV>
						</div>
						<br><br>
					</td>
					<td width=10 nowrap></td>
				</tr>
			</table>
			<uc1:sitebottom id="SiteBottom1" runat="server"></uc1:sitebottom>
		</form>
	</body>
</html>
<script runat="server">

override protected void OnInit(EventArgs e)
{
	//
	// CODEGEN: This call is required by the ASP.NET Web Form Designer.
	//
	InitializeComponent();
	base.OnInit(e);
}

/// <summary>
/// Required method for Designer support - do not modify
/// the contents of this method with the code editor.
/// </summary>
private void InitializeComponent()
{    
	this.DataGrid1.DataBinding += new System.EventHandler(this.DataGrid1_DataBinding);
	this.DataGrid1.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid1_DeleteCommand);
	this.AddAdminButton.DataBinding += new System.EventHandler(this.AddAdminButton_Click);
	this.AddAdminButton.Click += new System.EventHandler(this.AddAdminButton_Click);
}

protected override void OnLoad(EventArgs e)
{
	CuteChat.AppChatIdentity identity=CuteChat.ChatProvider.Instance.GetLogonIdentity();
	if(identity==null)
	{
		Response.Redirect("Login.aspx",true);
		return;
	}
	if(!CuteChat.ChatProvider.Instance.IsAdministrator(identity.UniqueId))
	{
		Response.Redirect("Login.aspx",true);
		return;
	}

	base.OnLoad (e);

	if(!IsPostBack)
	{
		DataGrid1.DataBind();
	}
}



private void DataGrid1_DataBinding(object sender, System.EventArgs e)
{
	DataTable table=new DataTable();

	using(IDbConnection conn= CuteChat.ChatProvider.Instance.CreateConnection())
	{
		conn.Open();

		IDbCommand cmd = conn.CreateCommand();
		cmd.CommandText="SELECT * FROM SampleUsers WHERE IsAdmin=1";
		using(IDataReader reader=cmd.ExecuteReader())
		{
			for(int i=0;i<reader.FieldCount;i++)
			{
				table.Columns.Add(reader.GetName(i),reader.GetFieldType(i));
			}
			object[] values=new object[reader.FieldCount];
			while(reader.Read())
			{
				reader.GetValues(values);
				table.Rows.Add(values);
			}
		}
	}

	table.AcceptChanges();

	DataGrid1.DataSource=table.DefaultView;
}

private void DataGrid1_DeleteCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
{
	string loginName=(string)DataGrid1.DataKeys[e.Item.ItemIndex];

	GlobalAsax.ExampleProvider.UpdateIsAdmin(loginName,false);

	DataGrid1.DataBind();
}


private void AddAdminButton_Click(object sender, System.EventArgs e)
{
	string loginName=AdminUsernameBox.Text.Trim();
	if(!CuteChat.ChatProvider.Instance.UserExists(loginName))
	{
		MessageLabel.Text="User not exists!";
		MessageLabel.Visible=true;
		return;
	}

	GlobalAsax.ExampleProvider.UpdateIsAdmin(loginName,true);

	DataGrid1.DataBind();
}
</script>
